Added new Dynamic Range Compression option for HandBrake encodings.
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index 4e37c54a9766a4250446430032fd79a6d512e7a9..aa4b13ba6ae64c2dac4186e9b02df8ea85ce0637 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -3,7 +3,7 @@
 # Author: Alan J. Pippin (apippin@pippins.net)
 # Date: 05/17/2009
 #
-  REV=1.0
+  REV=2.0
 #
 # Description: This script wraps a number of linux utilities to
 # create a recipe for ripping protected DVDs, circumventing 
 # Known Issues/Limitations:
 # - Mirror mode is always done in ISO mode
 #
-# Package Dependencies:
-# lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
+# Package Dependencies (apt-get install these for example):
+# lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
+#
+# Specific Executable (program) Dependencies (must be found in $PATH):
+# volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
 #
 # Optional Dependencies:
 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
 #
 
-###############################################
-# Local Machine Settings - EDIT THIS SECTION
-
-# Specify the device path to the DVD drive
-dev=/dev/dvd2
-
-# Specify the path to the log directory 
-logdir=/var/log/ripdvd
-
-# Specify the path to the tmp rip directory
-tmpdir=/myth/video/DVDs/.ripdvd
-
-# Specify the email address to send job notifications to
-mailto=ajp@pippins.net
-
-# Setup the path to the tools needed by this ripper
-PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
-
-# Use mplayer dumpstream to create the main VOB file
-# If set to 0, cat and other utils will be used to make it instead.
-# Using mplayer dumpstream is by far the best way to create the main VOB file
-# The only thing this doesn't work for are DVDs with the 99 title copy protection.
-# The script will autodetect these types of disks, and change this to 0 if necessary.
-# If this is set to 0, other methods will be employed to get the DVD VOB dump.
-use_mplayer_dumpstream=1
-
-# 2-channel AVI encoding audio bit rate
-audio_bitrate=224
-
-# If set to 1, this script will call another script to fill in the mythvideo metadata
-# If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
-# the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
-fill_mythvideo_metadata=1
-
-# If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
-# The autodetection may work, but it probably won't in this case. Set to 0 by default. 
-# Override to 1 if you want the script to wing it, and hope it picks the right feature title.
-trust_feature_title_autodetect_when_uncertain=0
-
-###############################################
-# Command line processing
+##############################################################################################
+# Global Variables
+##############################################################################################
+typeset cmd="$0 $*"
 typeset dvdname=""
 typeset debug=""
 typeset dest=""
 typeset isofile=""
+typeset vobfile=""
 typeset dvdpath=""
+typeset aspect=""
+typeset SCALE=""
+typeset CROP=""
+typeset profile="xvidhq"
+typeset extension=""
+typeset mailto=""
+typeset encoder=""
+typeset default_alang="en"
+typeset track=""
+typeset drc="0.0"
+typeset -i default_aid=128
+typeset -i aid_override=-1
+typeset -i force_onepass_mode=0
+typeset -i eject_disk=1
+typeset -i keep_isofile=0
+typeset -i keep_vobfile=0
+typeset -i keep_dvdfolder=0
 typeset -i keep_intermediate_files=0
 typeset -i make_final_dest_vob=0
 typeset -i make_final_dest_iso=0
 typeset -i make_final_dest_folder=0
-typeset -i make_final_dest_avi=0
+typeset -i make_final_dest_comp=0
 typeset -i errors=0
 typeset -i show_usage=0
 typeset -i mirror_mode=0
-typeset -i target_bitrate=0
+typeset -i target_bitrate=2000
 typeset -i target_size=0
 typeset -i audio_2ch=0
+typeset -i audio_6ch=1
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
 
-while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
+##############################################################################
+# Local Machine Settings:
+# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
+# and the local conf file created by each local machine (rip_dvd.conf)
+# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
+# This will allow you to override all the default values to meet your needs
+# in a way that won't get clobbered when you pull updates from my GIT repo.
+##############################################################################
+config="${0%/*}/rip_dvd.conf"
+
+# The config file will be searched for in the following location order:
+found_config=0
+
+# 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
+[ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
+
+# 2) /path/to/rip_dvd/script/rip_dvd.conf
+[ -e "${config}" ] && found_config=1 && . "${config}"
+
+# 3) /etc/rip_dvd.conf
+[ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
+
+# 4) $PWD/rip_dvd.conf
+[ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
+
+# Check to make sure we found the config file
+if [ $found_config -eq 0 ]; then
+  echo "-E- Unable to find the rip_dvd.conf file: $config"
+  exit 1
+fi
+
+##############################################################################################
+# Command line processing
+##############################################################################################
+while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
@@ -91,14 +110,23 @@ do
         (b)     target_bitrate=$OPTARG;;
        (s)     target_size=$OPTARG;;
         (2)     audio_2ch=1;;
+        (6)     audio_6ch=1;;
+        (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
         (f)     make_final_dest_folder=1;; 
-        (x)     make_final_dest_avi=1;;
+        (z)     make_final_dest_comp=1;;
+       (e)     encoder=$OPTARG;;
         (m)     mirror_mode=1;;
         (k)     keep_intermediate_files=1;;
         (t)     feature_title_override=$OPTARG;;
-        (w)     set -$opt;;
+       (a)     aspect=$OPTARG;;
+       (p)     profile=$OPTARG;;
+       (x)     extension=$OPTARG;;
+       (j)     eject_disk=$OPTARG;;
+       (l)     aid_override=$OPTARG;;
+       (r)     drc=$OPTARG;;
+        (w)     set -x;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
@@ -112,25 +140,56 @@ function usage() {
     echo >&2 "Revision $REV"
     echo >&2 "Options:"
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
-    echo >&2 "   -n <dvdname>  Specify what the name of the DVD is to process from $tmpdir"
-    echo >&2 "                 If it is a full path to a DVD folder, it will be ripped instead of $dev"
-    echo >&2 "                 This is optional. If not specified, the dvd will be pulled from $dev"
+    echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
+    echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
+    echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
+    echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
+    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
+    echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
+    echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
+    echo >&2 "                 Handbrake Only Encoder Profiles:"
+    echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
+    echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
+    echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
     echo >&2 "                 The default operation is non-mirror mode where only the main"
     echo >&2 "                 feature title will be ripped."
     echo >&2 "   -v            Make the final image a DVD VOB file"
     echo >&2 "   -i            Make the final image a DVD ISO file"
     echo >&2 "   -f            Make the final image a DVD folder"
-    echo >&2 "   -x            Make the final image an AVI (XVID) file"
-    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
-    echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
-    echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
-    echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
+    echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
+    echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
+    echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
+    echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
+    echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
+    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
+    echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
+    echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
+    echo >&2 "   -j <n>        Eject the disk:"
+    echo >&2 "                 - 0 = do not eject the disk"
+    echo >&2 "                 - 1 = eject after the entire script is done (default)"
+    echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
+    echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
+    echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
+    echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
+    echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
+    echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
+    echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
-    echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
+    echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
+    echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
-    echo >&2 "   -w            Set the sh Execute/Verbose flag"
+    echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
     echo >&2 ""
     exit 2
 }
@@ -146,30 +205,70 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
-  echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
-  usage
+if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
+   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
+    # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
+    make_final_dest_comp=1
 fi
 
-if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
-  echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
+if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
+  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
-if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
-   [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
-  echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
+if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
+  echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
   usage
 fi
 
 if [ $mirror_mode -eq 1 ]; then
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
-     [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
-    echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
+     [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
+    echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
     usage
   fi
 fi
 
+# Make handbrake the default encoder if not specified and we can find it
+if [ -z "$encoder" ]; then
+  encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
+  [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
+  [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
+fi
+
+# Sanity check the profile selection
+if [[ "$encoder" == "mencoder" ]]; then
+  [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
+fi
+
+if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
+  echo "-E- Invalid encoder specified: $encoder"
+  exit 1
+fi
+
+# If the aspect ratio option was specified, set the scale variable appropriately for mencoder
+if [ "$aspect" != "" ]; then
+  echo "$aspect" | grep -q "x"
+  if [ $? == 0 ]; then
+    echo "-E- You must specify the aspect option with a value whose format is W:H"
+    exit 1
+  fi
+  echo "$aspect" | grep -q ":"
+  if [ $? != 0 ]; then
+    [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
+    [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
+  else
+    [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
+    if [ "$encoder" == "handbrake" ]; then
+       WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
+       HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
+       SCALE="-w $WIDTH -l $HEIGHT"
+    fi
+  fi
+fi
+
 # Sanity Check - Key executables
 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
@@ -179,11 +278,17 @@ fi
 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
+[[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
 
-###############################################
+##############################################################################################
 
 typeset -i ripdvd
 if [ -z "$dvdname" ]; then
+
   # make sure the DVD device is accessible
   volname $dev > /dev/null 2>&1
   if [ $? != 0 ]; then
@@ -193,31 +298,108 @@ if [ -z "$dvdname" ]; then
   # now capture the volume name from the device
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
+
 else 
+
   # check to see if dvdname is a full path to a real directory
   # if it is, set dvdname and dvdpath appropriately
   if [ -d "$dvdname" ]; then
     dvdpath="$dvdname"
     dvdname=`basename "$dvdname"`
+    keep_dvdfolder=1
     if [ -z "$dvdname" ]; then
-     fatal_and_exit "-E- Unable to extract dvdname from path: $dvdpath"
+     echo "-E- Unable to extract dvdname from path: $dvdpath"
+     exit 1
     fi
     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
-      fatal_and_exit "-E- You must supply a full path to a valid DVD folder with this option"
+      echo "-E- You must supply a full path to a valid DVD folder with this option"
+      exit 1
     fi
   fi
+
+  # Check to see if dvdname is a full path to a file
+  if [ -f "$dvdname" ]; then
+    valid_file=0
+
+    # check to see if dvdname is a full path to an MPG2 (VOB) file
+    # if it is, set dvdname and vobfile appropriately
+    file "$dvdname" | grep -q "MPEG"
+    if [ $? == 0 ]; then
+      # It is a valid MPEG2 file, now strip the extension off our dvdname
+      vobfile="$dvdname"
+      dvdname=`basename "$dvdname"`
+      dvdname=${dvdname%.[^.]*}
+      keep_vobfile=1
+      valid_file=1
+    fi
+
+    # check to see if dvdname is a full path to an ISO file
+    # if it is, set dvdname and isofile appropriately
+    file "$dvdname" | grep -q -e "ISO" -e "UDF"
+    if [ $? == 0 ]; then
+      # It is a valid ISO file, now strip the extension off our dvdname
+      isofile="$dvdname"
+      dvdname=`basename "$dvdname"`
+      dvdname=${dvdname%.[^.]*}
+      keep_isofile=1
+      valid_file=1
+    fi    
+
+    # check to see if dvdname is a full path to an ISO file
+    # if it is, set dvdname and isofile appropriately
+    file "$dvdname" | grep -q -e "VOB"
+    if [ $? == 0 ]; then
+      # It is a valid VOB file, now strip the extension off our dvdname
+      vobfile="$dvdname"
+      dvdname=`basename "$dvdname"`
+      dvdname=${dvdname%.[^.]*}
+      keep_vobfile=1
+      valid_file=1
+    fi    
+
+    # If we didn't find a handler for the file above, complain
+    if [ $valid_file -eq 0 ]; then
+      echo "-E- Unsupported file type: $vobfile"
+      exit 1
+    fi
+
+  # Throw an error if we can't find what the -n option is pointing to
+  else 
+    echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
+    exit 1
+  fi
+
+  # Set the ripdvd flag to false since we aren't ripping a DVD disk
   ripdvd=0
+
+  # Since we aren't ripping a DVD disk, don't eject anything either
+  eject_disk=0
+
 fi
 
+# remove bad characters from the dvdname
+dvdname=${dvdname%.} # remove trailing '.' character
+
+# add the suffix extension to the end of the dvdname
+dvdname=$dvdname$extension
+
+# make a "safe" dvdname (remove special characters)
+safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
+
 # Make sure we have a non-empty dvdname
 if [ -z "$dvdname" ]; then
   echo "-E- unable to determine dvdname"
   exit 1
 fi
 
+# make sure our vobfile value is set
+if [ -z "$vobfile" ]; then
+  vobfile="$dest/$dvdname.VOB"
+fi
+
 # set up some variables to hold various logfiles
 logfile="$logdir/$dvdname.log"
-passlogfile="$tmpdir/divx2pass.log"
+passlogfile="$tmpdir/$safedvdname.log"
 ddrescuelog=`tempfile`
 dvdauthorlog=`tempfile`
 encodelog=`tempfile`
@@ -241,8 +423,9 @@ if [ ! -d "$logdir" ]; then
   fi
 fi
 
-###############################################
+##############################################################################################
 # cleanup functions
+##############################################################################################
 cleanup() { 
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
@@ -268,6 +451,7 @@ fatal_and_exit() {
   if [[ -n "$mailto" ]]; then
     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
   fi
+  keep_intermediate_files=1
   exit 1
 }
 
@@ -275,8 +459,341 @@ fatal_and_exit() {
 trap fatal_and_exit INT
 trap cleanup EXIT
 
-###############################################
+##############################################################################################
 # processing functions
+##############################################################################################
+
+# encode the vob file into a compressed file format using handbrake
+function encode_vob_file_handbrake {
+  
+  # declare some globals
+  typeset handbrake_cli=""
+  typeset handbrake_video_encoder_opts=""
+  typeset filetype=""
+  typeset handbrake_audio_opts=""
+  typeset hb_profile=""
+
+  # Set a variable that we will use later to determine if we found a handler for $profile or not
+  typeset -i found_profile=0    
+
+  # For a given profile, to override the 2 pass behavior to be single pass,
+  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
+  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  PASSES="-2"
+
+  # Set our DRC option
+  DRC="-D $drc"
+
+  # Check the global force_onepass_mode. If it is set, change our variables appropriately
+  # to force 1-pass encoding across all profiles.
+  if [ $force_onepass_mode -eq 1 ]; then
+    PASSES=""
+  fi
+
+  # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
+  get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
+
+  # XVID profile
+  if [[ "$profile" =~ "xvid" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_xvid"
+    final_output_file="$dest/$dvdname.avi"
+    filetype="avi"
+
+    # Very High Quality (16fps)
+    if [ "$profile" == "xvidvhq" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e xvid"
+      handbrake_opts[3]="-T"
+      handbrake_opts[4]="-5"
+      handbrake_opts[5]="-8"
+    fi
+    # High Quality (20fps)
+    if [ "$profile" == "xvidhq" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e ffmpeg"
+      handbrake_opts[3]="-T"
+      handbrake_opts[4]="-5"
+    fi
+    # Fast (28fps)
+    if [ "$profile" == "xvid" ]; then
+      handbrake_opts[0]="-f avi"
+      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[2]="-e ffmpeg"
+      handbrake_opts[3]="-T"
+    fi
+  fi
+
+  # MP4 profile
+  if [[ "$profile" =~ "mp4" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+
+    # Very High Quality
+    if [ "$profile" == "mp4vhq" ]; then
+      profile="hb_High_Profile"
+    fi
+    # High Quality
+    if [ "$profile" == "mp4hq" ]; then
+      profile="hb_Normal"
+    fi
+    # Fast
+    if [ "$profile" == "mp4" ]; then
+      profile="hb_Classic"
+    fi
+  fi
+
+  # iphone and ipod MP4 profiles
+  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+
+    # iphone
+    if [ "$profile" == "iphone" ]; then
+      profile="hb_iPhone"
+    fi
+    # ipod
+    if [ "$profile" == "ipod" ]; then
+      profile="hb_iPod"
+    fi
+  fi
+  
+  # Predefined Handbrake Profile Handling
+  if [[ "$profile" =~ "hb" ]]; then
+    found_profile=1
+    handbrake_cli="$handbrake_mp4"
+    final_output_file="$dest/$dvdname.mp4"
+    PASSES=""
+    
+    # extract the HandBrake Profile name from $profile
+    hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
+  fi
+
+  # Make sure we found a handler for the given profile
+  if [ $found_profile -eq 0 ]; then
+    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
+  fi
+
+  # setup our audio option
+  if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
+    handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
+  fi
+  if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
+    handbrake_audio_opts="-E ac3 -6 auto"
+  fi
+  if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
+    handbrake_audio_opts="-E faac -6 dpl2"
+  fi
+  if [ -n "$track" ]; then
+    handbrake_audio_opts="$handbrake_audio_opts -a $track"
+  fi
+
+  # Convert our array of opts into a string
+  for OPTS in "${video_encoder_opts[@]}"; do 
+    handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
+  done
+  if [ -n "$handbrake_video_encoder_opts" ]; then
+    handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
+  fi
+  for OPTS in "${handbrake_opts[@]}"; do 
+    handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
+  done
+
+  # Append "global" command line options
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
+
+  # Execute the handbrake command to encode the video
+  if [ -n "$hb_profile" ]; then
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  else 
+    echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
+    $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
+    handbrake_retval=$?
+  fi
+  if [ $handbrake_retval != 0 ]; then
+    fatal_and_exit "-E- Unhandled handbrake error"
+  fi
+
+  # Concatenate the encode log to our main log file, greping out unwanted lines
+  cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
+  cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
+  cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
+}
+
+# encode the vob file into a compressed file format using mencoder
+function encode_vob_file_mencoder {
+
+  # Set a variable that we will use later to determine if we found a handler for $profile or not
+  typeset -i found_profile=0
+
+  # For a given profile, to override the 2 pass behavior to be single pass,
+  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
+  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  PASSES="1 2"
+
+  # Declare our default 2 pass variables
+  passlogfile_opt="-passlogfile $passlogfile"
+  pass_opt="pass=%PASS"
+
+  # Check the global force_onepass_mode. If it is set, change our variables appropriately
+  # to force 1-pass encoding across all profiles.
+  if [ $force_onepass_mode -eq 1 ]; then
+    PASSES="2"
+    passlogfile_opt=""
+    pass_opt=""    
+  fi
+
+  # XVID profile
+  if [[ "$profile" =~ "xvid" ]]; then
+    found_profile=1
+    final_output_file="$dest/$dvdname.avi"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
+    mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
+    mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
+    mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
+
+    # Very High Quality (16fps)
+    if [ "$profile" == "xvidvhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=4"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # High Quality (20fps)
+    if [ "$profile" == "xvidhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=2"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # Fast (28fps)
+    if [ "$profile" == "xvid" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="vhq=0"
+      video_encoder_opts[3]="turbo"
+      video_encoder_opts[4]="autoaspect"
+    fi
+
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    if [ $audio_2ch -eq 0 ]; then
+      # These options produce good 6 channel audio for linux and windows
+      mencoder_audio_opts="-oac copy"
+      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+      mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+      mencoder_audioch_opts[1]="-af channels=6"
+      mencoder_audioch_opts[2]=""
+    else
+      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      mencoder_audioch_opts[0]=""
+    fi
+  fi
+
+  # iphone and ipod MP4 profiles
+  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
+    found_profile=1
+    if [ "$profile" == "iphone" ]; then
+      # SCALE: 480x320
+      # scale width to 480, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=480:-10"
+      # scale the video down however far is necessary to fit in 480x320
+      SCALE=",dsize=480:320:0,scale=-8:-8"
+    else
+      # SCALE: 320x240
+      # scale width to 320, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=320:-10"
+      # scale the video down however far is necessary to fit in 320x240
+      SCALE=",dsize=320:240:0,scale=-8:-8"
+    fi
+    final_output_file="$dest/$dvdname.mp4"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
+    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
+    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
+    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[1]="threads=$mencoder_threads"
+    video_encoder_opts[2]="vbv_maxrate=1500"
+    video_encoder_opts[3]="vbv_bufsize=2000"
+    video_encoder_opts[4]="nocabac"
+    video_encoder_opts[5]="me=umh"
+    video_encoder_opts[6]="subq=6"
+    video_encoder_opts[7]="frameref=6"
+    video_encoder_opts[8]="trellis=1"
+    video_encoder_opts[9]="level_idc=30"
+    video_encoder_opts[10]="global_header"
+    video_encoder_opts[11]="bframes=0"
+    video_encoder_opts[12]="partitions=all"
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+    mencoder_audioch_opts[0]="-channels 2 -srate 48000"
+  fi
+
+  if [ $found_profile -eq 0 ]; then
+    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
+  fi
+
+  # Do not edit this line. $mencoder_video_encoder_opts must be last
+  mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
+  mencoder_retval=0
+
+  for PASS in $PASSES
+  do 
+    # Set some options based on which pass we are in
+    mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
+    [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
+    [ $PASS -eq 1 ] && output_file="/dev/null"
+    [ $PASS -eq 2 ] && output_file="$final_output_file"
+  
+    # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
+    for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
+    do
+      echo -e "   Encoding pass $PASS"
+      echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
+      mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
+      mencoder_retval=$? 
+      grep -q "\[channels\] Invalid" $encodelog
+      if [ $? != 0 ]; then         
+        break;
+      else
+        echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
+      fi
+    done
+      
+    if [ $mencoder_retval != 0 ]; then
+      fatal_and_exit "-E- Unhandled mencoder error"
+    fi
+
+    # Concatenate the encode log to our main log file, greping out unwanted lines
+    cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
+
+  done
+}
+
 function make_dvd_iso_image {
 
   isofile="$1"
@@ -297,10 +814,7 @@ function make_dvd_iso_image {
     cat "$ddrescuelog" >> "$logfile"
   else
     # rip from a path instead
-    make_dvd_iso_image_from_folder "$dvdpath" "$isofile"
-    if [ ! -s "$isofile" ]; then
-      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
-    fi
+    make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
   fi
 }
 
@@ -308,14 +822,32 @@ function make_dvd_iso_image_from_folder {
   
   src="$1"
   dst="$2"
+  handle_error=$3
   
   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
 
   # make an iso image out of our directory
   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
-  if [ $? != 0 ]; then
-    fatal_and_exit '-E- mkisofs -dvd-video "$src" | dd of="$dst" obs=32k seek=0 failed'
+
+  # set the audio languages from the iso if it exists and is non-zero in size
+  if [ -s "$dst" ]; then
+    get_feature_title "$dst"
+    get_audio_id_from_iso "$dst"
+  fi
+
+  # make sure we were able to create the iso image from the folder given to us
+  if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
+    echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
+    echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
+    # remove the bad iso file
+    [[ -e "$dst" ]] && rm -f "$dst"
+    # get the feature title from the DVD folder
+    get_feature_title "$dvdpath"
+    # create our main VOB file from the ISO
+    create_main_vob_with_mplayer "$dvdpath" 
+    # get our audio id from the VOB file
+    get_audio_id_from_vob "$vobfile"
   fi
 }
 
@@ -362,6 +894,7 @@ function make_dvdauthor_folder_image {
 }
 
 function get_feature_title {
+  source="$1"
   # if a feature title was given on the command line, use it
   if [ $feature_title_override -ne 0 ]; then
     feature_title=$feature_title_override
@@ -371,7 +904,7 @@ function get_feature_title {
   if [ $ripdvd -eq 1 ]; then
     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
   else 
-    feature_title=`lsdvd "$isofile" | awk '/Longest/ { print $NF }'`
+    feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
   fi
 }
 
@@ -391,6 +924,11 @@ function create_main_vob_with_cat {
 }
 
 function create_main_vob_with_mplayer {
+
+  # argument processing  
+  source="$1"
+  remove_dumplog=$2
+
   # make sure we have a valid feature title
   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
@@ -405,10 +943,9 @@ function create_main_vob_with_mplayer {
   fi
 
   # use mplayer to create the main VOB file
-  remove_dumplog=$1
-  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a "$logfile"
-  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
-  mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
+  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
+  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
+  mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
   if [ $? != 0 ]; then
     cat $dumplog | grep -v "^A:" >> "$logfile"
     fatal_and_exit "-E- Mplayer Failed"
@@ -420,18 +957,24 @@ function create_main_vob_with_mplayer {
 function get_audio_id_from_iso {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  iso="$1"
   aidcheck=`tempfile`
-  aid=128
-  mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
-  grep -q "aid: $aid" $aidcheck
-  while [ $? == 1 ] && [ $aid -lt 159 ]; do
-    (( aid = aid + 1 ))
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
     grep -q "aid: $aid" $aidcheck
-  done
-  [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "aid: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else
+    aid=$aid_override
+  fi
   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
-  lang_opts="-aid $aid -alang en"
+  lang_opts="-aid $aid -alang $alang"
 }
 
 function get_crop_from_iso { 
@@ -448,7 +991,8 @@ function get_crop_from_iso {
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
-    fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
   fi
   if [ $CROPCHECK -lt 0 ]; then 
     CROP=""
@@ -458,21 +1002,93 @@ function get_crop_from_iso {
   echo "   Setting mencoder crop filter to: $CROP"
 }
 
+function get_crop_from_vob { 
+  FRAMES=10000
+  echo "-> Detecting black frame border crop value from VOB file"
+  echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
+  mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
+  [[ -e "md5sums" ]] && rm -f "md5sums"
+  CROP=`cat $dumplog | grep CROP | tail -1`
+  echo "   Found crop value of $CROP" >> "$logfile"
+  CROP=${CROP#* crop=}
+  CROP=${CROP%%\).*}
+  typeset -i CROPCHECK
+  CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
+  echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
+  if [ -z "$CROP" ]; then
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
+  fi
+  if [ $CROPCHECK -lt 0 ]; then 
+    CROP=""
+  else 
+    CROP=",crop=$CROP"
+  fi
+  echo "   Setting mencoder crop filter to: $CROP"
+}
+
+function get_audio_track_from_vob {
+  # Adjust our audio ID to find the english audio stream
+  # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  vob="$1"
+  handbrake_cli="$2"
+  aidcheck=`tempfile`
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
+    grep -q "Found audio stream: $aid" $aidcheck
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "Found audio stream: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else 
+    aid=$aid_override
+  fi
+  # Now that we've found the right audio id, find the corresponding audio track in HandBrake
+
+  # convert the aid we found into hex
+  aid_hex=`echo "obase=16; $aid" | bc`
+  
+  # extract the audio streams in the vob
+  #ffmpeg -i "$vob" > $aidcheck 2>&1
+  $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
+  
+  # find the stream that matches our aid
+  #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
+  stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
+  # extract the track number that handbrake uses
+  #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
+  track=`expr match "$stream" '^\([0-9]*\):'`
+
+  if [ -n "$track" ]; then   
+    echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
+  fi
+}
+
 function get_audio_id_from_vob {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  vob="$1"
   aidcheck=`tempfile`
-  aid=128
-  mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
-  grep -q "Found audio stream: $aid" $aidcheck
-  while [ $? == 1 ] && [ $aid -lt 159 ]; do
-    (( aid = aid + 1 ))
+  aid=$default_aid
+  alang=$default_alang
+  if [ $aid_override -lt 0 ]; then 
+    mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
     grep -q "Found audio stream: $aid" $aidcheck
-  done
-  [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+    while [ $? == 1 ] && [ $aid -lt 159 ]; do
+      (( aid = aid + 1 ))
+      grep -q "Found audio stream: $aid" $aidcheck
+    done
+    [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
+  else 
+    aid=$aid_override
+  fi
   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
-  lang_opts="-aid $aid -alang en"
+  lang_opts="-aid $aid -alang $alang"
 }
 
 function check_vob_for_corrupted_start {
@@ -499,7 +1115,7 @@ function check_vob_for_corrupted_start {
   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
 
   # cat the giant VOB into mencoder to create a playable VOB file
-  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> "$logfile" 2>&1
+  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
   if [ $? != 0 ]; then
     fatal_and_exit "-E- Mencoder Failed"
   fi
@@ -513,14 +1129,14 @@ function check_vob_for_completeness {
   # detect this by seeing how much smaller the dst vob is from the src vob.
   MAX_FILESIZE_DELTA_PERCENT=70
   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
-  DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+  DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     [[ -e "$dumplog" ]] && rm -f $dumplog
-    DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+    DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
@@ -540,7 +1156,7 @@ function check_vob_for_too_many_video_packets {
   if [ $? == 0 ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     grep -q "Too many video packets in the buffer:" $dumplog
     if [ $? == 0 ]; then
       [[ -e "$dumplog" ]] && rm -f $dumplog
@@ -559,14 +1175,14 @@ function check_vob_for_a52_crc_errors {
   MAX_ERRORS=10
   ENDPOS=120
   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
-  mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+  mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
   cat $dumplog | grep -v "^A:" >> "$logfile"
   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
   if [ $errors -gt $MAX_ERRORS ]; then
     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
-    mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+    mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
     if [ $? != 0 ]; then
       cat $dumplog | grep -v "^A:" >> "$logfile"
       fatal_and_exit "-E- Mplayer Failed"
@@ -583,7 +1199,7 @@ function check_vob_for_a52_crc_errors {
 function calculate_bitrate_from_target_size {
   # determine what our bitrate needs to be if a target size was specified instead
   if [ $target_size -ne 0 ]; then
-    vob_length=`mplayer -identify -v "$dest/$dvdname.VOB" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+    vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
   fi
@@ -643,7 +1259,7 @@ function check_for_mplayer_dumpstream_incompatibility {
 
   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
 
-  if [ ! -e "$dest/$dvdname.VOB" ]; then
+  if [ ! -e "$vobfile" ]; then
     # mplayer dumpstream does not work on DVDs that obscure the feature title.
     # A DVD that has 99 titles, where the longest title isn't the main feature
     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
@@ -659,6 +1275,7 @@ function check_for_mplayer_dumpstream_incompatibility {
       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
+        echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
         invalid_feature_title=1
       else 
         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
@@ -675,9 +1292,9 @@ function check_for_mplayer_dumpstream_incompatibility {
   # This can be detected by telling mplayer to parse the VOB file by copying its audio
   # video streams to a dummy output file (/dev/null). Do that here to check for that 
   # problem before continuing.
-  if [ -e "$dest/$dvdname.VOB" ]; then
+  if [ -e "$vobfile" ]; then
     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
-    mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
+    mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
     grep -q "Too many audio packets in the buffer" $dumplog
     if [ $? == 0 ]; then
       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
@@ -711,8 +1328,8 @@ function fill_mythvideo_metadata {
   fi
 }
 
+# remove the intermediate VOB file
 function remove_intermediate_vob_file {
-  # remove the intermediate VOB file
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
   else
@@ -720,8 +1337,9 @@ function remove_intermediate_vob_file {
   fi
 }
 
+# remove the original DVD image 
 function remove_intermediate_iso_file {
-  # remove the original DVD image 
+  [[ $keep_isofile -eq 1 ]] && return 1
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -e "$isofile" ]] && rm "$isofile"
   else
@@ -729,6 +1347,7 @@ function remove_intermediate_iso_file {
   fi
 }
 
+# remove the intermediate dvdbackup folder
 function remove_intermediate_dvdbackup_folder {
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
@@ -737,12 +1356,14 @@ function remove_intermediate_dvdbackup_folder {
   fi
 }
 
-###############################################
+##############################################################################################
 # MAIN
+##############################################################################################
 
 # Make a note of when this DVD rip started
 date=`date`
 echo -e "\n$date DVD rip started" >> "$logfile"
+echo "$cmd" >> "$logfile"
 
 # Rip the DVD - Mirror Mode
 if [ $mirror_mode -eq 1 ]; then
@@ -755,7 +1376,9 @@ if [ $mirror_mode -eq 1 ]; then
   fill_mythvideo_metadata "$dest/$dvdname.iso" 
 
   # eject the disk upon completion
-  eject -T $dev
+  if [ $eject_disk -ne 0 ]; then
+    eject -T $dev
+  fi
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"
@@ -779,24 +1402,21 @@ if [ $mirror_mode -eq 0 ]; then
   # Rip image from DVD path
   if [ -n "$dvdpath" ]; then
     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
-    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso"
-    if [ ! -s "$tmpdir/$dvdname.iso" ]; then
-      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
-    fi
+    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
   fi
 
   # make sure our isofile value is set
   if [ -z "$isofile" ]; then
     isofile="$tmpdir/$dvdname.iso"
   fi
-   
-  if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
+     
+  if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
 
-    if [ ! -e "$dest/$dvdname.VOB" ]; then
-      echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a "$logfile"
+    if [ ! -e "$vobfile" ]; then
+      echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
       
       # get the feature title from the ISO
-      get_feature_title
+      get_feature_title "$isofile"
  
       # get the crop value from the ISO
       get_crop_from_iso
@@ -808,10 +1428,10 @@ if [ $mirror_mode -eq 0 ]; then
       if [ $use_mplayer_dumpstream -eq 1 ]; then 
 
         # get our audio id from the ISO file
-        get_audio_id_from_iso
+        get_audio_id_from_iso "$isofile"
 
         # create our main VOB file from the ISO
-        create_main_vob_with_mplayer        
+        create_main_vob_with_mplayer "$isofile"
      
         # remove the intermediate VOB file
         remove_intermediate_vob_file
@@ -831,7 +1451,7 @@ if [ $mirror_mode -eq 0 ]; then
         create_main_vob_with_cat
 
         # get our audio id from the VOB file
-        get_audio_id_from_vob
+        get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
   
         # check for corrupted VOB start
         check_vob_for_corrupted_start
@@ -854,96 +1474,45 @@ if [ $mirror_mode -eq 0 ]; then
       remove_intermediate_iso_file
 
     else
-      echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a "$logfile"
+      if [ "$encoder" != "handbrake" ]; then 
+        echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
+        # get our audio id from the VOB file
+        get_audio_id_from_vob "$vobfile"
+        # get the crop value from the VOB
+        get_crop_from_vob
+      fi
     fi
 
-    # transcode the DVD
-    if [ $make_final_dest_avi -eq 1 ]; then
-      echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
+    # eject the DVD disk since we are finished with it
+    [ $eject_disk -eq 2 ] && eject -T $dev
+
+    # encode the VOB file to a compressed file format
+    if [ $make_final_dest_comp -eq 1 ]; then
+      echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
 
       # determine what our bitrate needs to be if a target size was specified instead
       calculate_bitrate_from_target_size        
-      
-      # There was a lot of experimentation to arrive at these values
-      # These seem to work OK for me. If they don't work for you, feel
-      # free to adjust/change as needed.
-
-      # Edit these as needed to suite your needs
-      mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-      mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
-      mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
-      mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
-
-      # There are a number of different ways to encode 6 channel audio.
-      # I've loaded 3 different ways into the mencoder_audioch_opts.
-      # It will cycle through them until it finds one that works. 
-      # You can change the order to suit your needs.
-      if [ $audio_2ch -eq 0 ]; then
-
-        # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
-        #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
-        #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
-
-        # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
-        # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
-        mencoder_audio_opts="-oac copy"
-
-        # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
-        mencoder_audioch_opts[0]="-channels 6 -af channels=6"
-        mencoder_audioch_opts[1]="-af channels=6"
-        mencoder_audioch_opts[2]=""
-
-     else 
-        # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-        mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
-        mencoder_audioch_opts[0]=""
-     fi
-
-      # Do not edit this line. $mencoder_video_encoder_opts must be last
-      mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
-      mencoder_retval=0
-
-      for PASS in 1 2 
-      do 
-        # Set some options based on which pass we are in
-        mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
-       [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
-        [ $PASS -eq 1 ] && output_file="/dev/null"
-        [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
-  
-        # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
-        for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
-        do
-          echo -e "   Encoding pass $PASS"
-          echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
-          mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
-          mencoder_retval=$? 
-          grep -q "\[channels\] Invalid" $encodelog
-          if [ $? != 0 ]; then     
-            break;
-          else
-            echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
-          fi
-        done
-        if [ $mencoder_retval != 0 ]; then
-          fatal_and_exit "-E- Unhandled mencoder error"
-        fi
-        # Concatenate the encode log to our main log file, greping out unwanted lines
-        cat $encodelog | grep -v "Pos:" >> "$logfile"
-      done
+     
+      # encode the vob file into a compressed file format
+      if [[ "$encoder" == "mencoder" ]]; then 
+        encode_vob_file_mencoder
+      fi
+      if [[ "$encoder" == "handbrake" ]]; then
+        encode_vob_file_handbrake
+      fi
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
-        [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
+        [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
       else
-        echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a "$logfile"
+        echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
       fi
     fi
 
   # add this video data to the mythtv DB
-  [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi
-  [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.VOB
+  [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file
+  [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile
     
   else
 
@@ -971,7 +1540,7 @@ if [ $mirror_mode -eq 0 ]; then
   if [ $make_final_dest_iso -eq 1 ]; then
 
     # make an iso image out of our directory
-    make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso"
+    make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
    
     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
     if [ -s "$dest/$dvdname.iso" ]; then
@@ -1001,7 +1570,7 @@ if [ $mirror_mode -eq 0 ]; then
   remove_intermediate_dvdbackup_folder
 
   # eject the DVD disk upon completion
-  [ $ripdvd -eq 1 ] && eject -T $dev
+  [ $eject_disk -eq 1 ] && eject -T $dev
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"
@@ -1012,3 +1581,4 @@ if [ $mirror_mode -eq 0 ]; then
 
 fi
 
+##############################################################################################